"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Handlebars = require("handlebars");
const components_1 = require("typedoc/dist/lib/output/components");
let BreadcrumbsComponent = class BreadcrumbsComponent extends components_1.ContextAwareRendererComponent {
    initialize() {
        super.initialize();
        const component = this;
        Handlebars.registerHelper('breadcrumbs', function () {
            return component.breadcrumb(this.model, this.project, []);
        });
    }
    breadcrumb(model, project, md) {
        const theme = this.application.renderer.theme;
        if (model && model.parent) {
            this.breadcrumb(model.parent, project, md);
            if (model.url) {
                md.push(`[${model.name}](${Handlebars.helpers.relativeURL.call(this, model.url)})`);
            }
            else {
                md.push(model.url);
            }
        }
        else {
            if (!!project.readme) {
                md.push(`[${project.name}](${Handlebars.helpers.relativeURL.call(this, theme.indexName + theme.fileExt)})`);
            }
            md.push(`[${project.readme ? 'Globals' : project.name}](${Handlebars.helpers.relativeURL.call(this, project.url)})`);
        }
        return md.join(' › ');
    }
};
BreadcrumbsComponent = __decorate([
    components_1.Component({ name: 'breadcrumbs' })
], BreadcrumbsComponent);
exports.BreadcrumbsComponent = BreadcrumbsComponent;
