"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Handlebars = require("handlebars");
const components_1 = require("typedoc/dist/lib/output/components");
let OptionsComponent = class OptionsComponent extends components_1.ContextAwareRendererComponent {
    initialize() {
        super.initialize();
        const platform = this.application.options.getValue('platform');
        const namedAnchors = this.application.options.getValue('namedAnchors');
        const hideBreadcrumbs = this.application.options.getValue('hideBreadcrumbs');
        const hideIndexes = this.application.options.getValue('hideIndexes');
        const hideSourceFiles = this.application.options.getValue('hideSources');
        Handlebars.registerHelper('ifNamedAnchors', function (options) {
            if (namedAnchors) {
                return options.fn(this);
            }
            return options.inverse(this);
        });
        Handlebars.registerHelper('ifMainTitle', function (options) {
            if (platform === 'docusaurus') {
                return options.inverse(this);
            }
            return options.fn(this);
        });
        Handlebars.registerHelper('ifBreadcrumbs', function (options) {
            if (hideBreadcrumbs || platform === 'gitbook' || platform === 'vuepress') {
                return options.inverse(this);
            }
            return options.fn(this);
        });
        Handlebars.registerHelper('ifIndexes', function (options) {
            if (hideIndexes || platform === 'vuepress') {
                return options.inverse(this);
            }
            return options.fn(this);
        });
        Handlebars.registerHelper('ifSources', function (options) {
            if (hideSourceFiles) {
                return options.inverse(this);
            }
            return options.fn(this);
        });
    }
};
OptionsComponent = __decorate([
    components_1.Component({ name: 'options' })
], OptionsComponent);
exports.OptionsComponent = OptionsComponent;
